<template>
    <div>
        <v-form 
            @submit.prevent="submit"
            v-model="valid"
            ref="form" 
            >
            <v-container>
                <v-row>
                    <v-col>
                        <v-text-field
                            v-model="form.title"
                            label="Enter list title..."
                            required
                            :rules="[
                                v => !!v || 'Title is required',
                                v => (v && v.length < 20) || 'Title must be less than 20 characters',
                            ]"
                        ></v-text-field>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col>
                        <v-btn type="submit">Add list</v-btn>
                        <v-btn @click="cancel">Cancel</v-btn>
                    </v-col>
                </v-row>
            </v-container>
        </v-form>
    </div>
</template>

<script>
    export default {
        name: "NewListForm",
        props:['onCreate', 'onCancel'],
        data:()=>({
            valid: true,
            form:{
                title: '',
            }
        }),
        methods:{
            submit(){
                this.$refs.form.validate()
                if(!this.valid) return;

                this.onCreate(this.form)
                this.reset();
            },
            reset(){
                this.form.title = '';
                this.$refs.form.resetValidation()
            },
            cancel(){
                this.onCancel();
            }
        }
    }
</script>

<style lang="scss" scoped>

</style>